declare default element namespace 'http://пф.рф/МЗРК/2019-05-15';
declare namespace МСК4 = "http://пф.рф/ВВ/МСК/2017-12-13";
declare namespace УТ = "http://пф.рф/УТ/2017-08-21";
declare namespace МСКР5 = "http://пф.рф/ВВ/МСКР/типы/2019-05-15";
declare variable $document as document-node() external;
declare variable $root := $document/ЭДПФР;
declare function local:nodeIndex($nodes as node()*, $nodeToFind as node()) as xs:integer
{
for $seq in (1 to count($nodes))
				return $seq[$nodes[$seq] is $nodeToFind]
};
declare function local:nodePosition($node as node()?) as node()
{

				element {xs:QName("Результат")}
				{
					let $prefixes := ()
					let $prefixes := for $s in in-scope-prefixes($root) return insert-before($prefixes, 1, $s)
					let $ns := ()
					let $ns := for $p in $prefixes return insert-before($ns, 1, concat('Q{', namespace-uri-for-prefix($p, $root), '}'))
					return local:replacePathWithPrefixes(path($node), $ns, $prefixes)
				}
			
};
declare function local:replacePathWithPrefixes($path as xs:string?, $namespaces as xs:string*, $prefixes as xs:string*) as xs:string?
{

				if (count($namespaces) > 0)
				   then local:replacePathWithPrefixes(
				   		replace($path, local:escape-for-regex($namespaces[1]), if (local:all-whitespace($prefixes[1])) then '' else concat($prefixes[1], ':')),
				          $namespaces[position() > 1],
				          $prefixes[position() > 1])
				   else $path
			
};
declare function local:escape-for-regex($arg as xs:string?) as xs:string
{

				replace($arg, '(\.|\[|\]|\\|\||\-|\^|\$|\?|\*|\+|\{|\}|\(|\))','\\$1')
			
};
declare function local:result($path as xs:string, $expected as xs:anyAtomicType, $objectName as xs:string, $objectValue as xs:anyAtomicType) as node()
{

				if ($path = '0') then
					element {xs:QName("Результат")}
					{
						$path
					}
				else
					element {xs:QName("Результат")}
					{
						element {xs:QName("ПутьДоЭлемента")}
						{
							$path
						},
						element {xs:QName("ОжидаемоеЗначение")}
						{
							$expected
						},
						element {xs:QName("Объект")}
						{
							element {xs:QName("Наименование")}
							{
								$objectName
							},
							element {xs:QName("Значение")}
							{
								$objectValue
							}
						}
					}
			
};
declare function local:valueInSequence($value as xs:anyAtomicType?, $seq as xs:anyAtomicType*) as xs:boolean
{
$value = $seq
};
declare function local:addYear($date as xs:date, $year as xs:integer) as xs:date
{
$date + xs:yearMonthDuration('P1Y') * $year
};
declare function local:all-whitespace($arg as xs:string?) as xs:boolean
{
normalize-space($arg) = ''
};
declare function local:isEmpty($element) as xs:boolean
{
local:all-whitespace(string($element))
};
declare function local:notExistsOrEmpty($element) as xs:boolean
{
not(exists($element)) or local:isEmpty($element)
};
declare function local:getResult($res as item()*) as item()*
{
if (exists($res)) then $res else local:result('0','','','')
};
<БлокПроверок ID="ВСЗЛ.ДокУЛ.1" name="Блок логических правил проверки документа, удостоверяющего личность">
<Проверка ID="1">
<Описание>Если тип документа отличен от 'СВИД О РОЖД', то Дата выдачи должна быть позже Даты рождения</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $anketaData:=$declar/Заявитель
let $idCard:=$declar/Заявитель/УТ:УдостоверяющийДокумент
return local:getResult(
					if (count($idCard) > 0) then
						for $ic in $idCard
							return if ($ic/УТ:Тип != 'СВИД О РОЖД') then
								let $dateBirth := $ic/parent::*/УТ:ДатаРождения  
								return if (local:notExistsOrEmpty($dateBirth)) then ()
									else
										if ($ic/УТ:ДатаВыдачи > $dateBirth) then ()
										else local:result(local:nodePosition($ic/УТ:ДатаВыдачи),'','','')
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>30</КодРезультата>
</Проверка>
<Проверка ID="2">
<Описание>Если тип документа - 'СВИД О РОЖД', то Дата выдачи должна быть позже либо равна Дате рождения</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $anketaData:=$declar/Заявитель
let $idCard:=$declar/Заявитель/УТ:УдостоверяющийДокумент
return local:getResult(
					if (count($idCard) > 0) then
						for $ic in $idCard
							return if ($ic/УТ:Тип = 'СВИД О РОЖД') then
								let $dateBirth := $ic/parent::*/УТ:ДатаРождения
								return if (local:notExistsOrEmpty($dateBirth)) then ()
									else
										if ($ic/УТ:ДатаВыдачи >= $dateBirth) then ()
										else local:result(local:nodePosition($ic/УТ:ДатаВыдачи),'','','')
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>30</КодРезультата>
</Проверка>
<Проверка ID="3">
<Описание>Дата рождения должна быть как минимум на 14 лет раньше 'Даты выдачи' 'ПАСПОРТА' или 'ПАСПОРТА РОССИИ'</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $anketaData:=$declar/Заявитель
let $idCard:=$declar/Заявитель/УТ:УдостоверяющийДокумент
return local:getResult(
					if (count($idCard) > 0) then
						for $ic in $idCard
							return if (local:valueInSequence($ic/УТ:Тип, ('ПАСПОРТ', 'ПАСПОРТ РОССИИ'))) then
								let $dateBirth := $ic/parent::*/УТ:ДатаРождения
								return if (local:notExistsOrEmpty($dateBirth)) then ()
									else
										if (local:addYear($dateBirth, 14) > $ic/УТ:ДатаВыдачи) then
											local:result(local:nodePosition($dateBirth),'','','')
										else ()
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>20</КодРезультата>
</Проверка>
<Проверка ID="4">
<Описание>Если тип документа - 'ПАСПОРТ', 'ПАСПОРТ РОССИИ', 'СВИД О РОЖД', 'ЗГПАСПОРТ', 'УДОСТ ОФИЦЕРА', 'ПАСПОРТ МОРФЛТ', 'ВОЕННЫЙ БИЛЕТ', 'ПАСПОРТ МОРЯКА', 'ВОЕН БИЛЕТ ОЗ', 'ДИППАСПОРТ РФ' или 'ЗГПАСПОРТ РФ', то 'Серия' должна быть указана</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $anketaData:=$declar/Заявитель
let $idCard:=$declar/Заявитель/УТ:УдостоверяющийДокумент
return local:getResult(
					if (count($idCard) > 0) then
						for $ic in $idCard
							return if (local:valueInSequence($ic/УТ:Тип, ('ПАСПОРТ', 'ПАСПОРТ РОССИИ', 'СВИД О РОЖД', 'ЗГПАСПОРТ', 'УДОСТ ОФИЦЕРА', 'ПАСПОРТ МОРФЛТ', 'ВОЕННЫЙ БИЛЕТ', 'ПАСПОРТ МОРЯКА', 'ВОЕН БИЛЕТ ОЗ', 'ДИППАСПОРТ РФ', 'ЗГПАСПОРТ РФ'))) then
								if (not(local:notExistsOrEmpty($ic/УТ:Серия))) then ()
								else local:result(local:nodePosition($ic),'','','')
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>20</КодРезультата>
</Проверка>
<Проверка ID="5">
<Описание>Если тип документа - 'ПАСПОРТ' или 'СВИД О РОЖД', то 'Серия' должна соответствовать шаблону '[римские цифры в диапазоне от I до XLIX] – [2 буквы русского алфавита]'</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $anketaData:=$declar/Заявитель
let $idCard:=$declar/Заявитель/УТ:УдостоверяющийДокумент
return local:getResult(
					if (count($idCard) > 0) then
						for $ic in $idCard
							return if (local:valueInSequence($ic/УТ:Тип, ('ПАСПОРТ', 'СВИД О РОЖД'))) then
								if (not(local:notExistsOrEmpty($ic/УТ:Серия))) then
									if (matches($ic/УТ:Серия,'^(XL?|X{0,3})(V?I{0,3}|I[VX])\-[А-ЯЁ]{2}$')) then () else local:result(local:nodePosition($ic/УТ:Серия),'','','')
								else local:result(local:nodePosition($ic),'','','')
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>40</КодРезультата>
</Проверка>
<Проверка ID="6">
<Описание>Если тип документа - 'ПАСПОРТ РОССИИ', то 'Серия' должна содержать 4 арабские цифры</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $anketaData:=$declar/Заявитель
let $idCard:=$declar/Заявитель/УТ:УдостоверяющийДокумент
return local:getResult(
					if (count($idCard) > 0) then
						for $ic in $idCard
							return if ($ic/УТ:Тип = 'ПАСПОРТ РОССИИ') then
								if (not(local:notExistsOrEmpty($ic/УТ:Серия))) then
									if (matches($ic/УТ:Серия,'^\d{4}$')) then () else local:result(local:nodePosition($ic/УТ:Серия),'','','')
								else local:result(local:nodePosition($ic),'','','')
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>40</КодРезультата>
</Проверка>
<Проверка ID="7">
<Описание>Если тип документа - 'ЗГПАСПОРТ', 'ДИППАСПОРТ РФ' или 'ЗГПАСПОРТ РФ', то 'Серия' должна содержать 2 арабские цифры</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $anketaData:=$declar/Заявитель
let $idCard:=$declar/Заявитель/УТ:УдостоверяющийДокумент
return local:getResult(
					if (count($idCard) > 0) then
						for $ic in $idCard
							return if (local:valueInSequence($ic/УТ:Тип, ('ЗГПАСПОРТ', 'ДИППАСПОРТ РФ', 'ЗГПАСПОРТ РФ'))) then
								if (not(local:notExistsOrEmpty($ic/УТ:Серия))) then
									if (matches($ic/УТ:Серия,'^\d{2}$')) then () else local:result(local:nodePosition($ic/УТ:Серия),'','','')
								else local:result(local:nodePosition($ic),'','','')
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>40</КодРезультата>
</Проверка>
<Проверка ID="8">
<Описание>Если тип документа - 'ВОЕННЫЙ БИЛЕТ', 'ПАСПОРТ МОРЯКА', 'ВОЕН БИЛЕТ ОЗ', 'УДОСТ ОФИЦЕРА' или 'ПАСПОРТ МОРФЛТ', то 'Серия' должна содержать ровно 2 буквы русского алфавита</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $anketaData:=$declar/Заявитель
let $idCard:=$declar/Заявитель/УТ:УдостоверяющийДокумент
return local:getResult(
					if (count($idCard) > 0) then
						for $ic in $idCard
							return if (local:valueInSequence($ic/УТ:Тип, ('ВОЕННЫЙ БИЛЕТ', 'ПАСПОРТ МОРЯКА', 'ВОЕН БИЛЕТ ОЗ', 'УДОСТ ОФИЦЕРА', 'ПАСПОРТ МОРФЛТ'))) then
								if (not(local:notExistsOrEmpty($ic/УТ:Серия))) then
									if (matches($ic/УТ:Серия,'^[А-ЯЁ]{2}$')) then () else local:result(local:nodePosition($ic/УТ:Серия),'','','')
								else local:result(local:nodePosition($ic),'','','')
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>40</КодРезультата>
</Проверка>
<Проверка ID="9">
<Описание>Если тип документа - 'ВОЕННЫЙ БИЛЕТ', 'ПАСПОРТ МОРЯКА' или 'ВОЕН БИЛЕТ ОЗ', то элемент 'Номер' должен содержать в первой позиции арабскую цифру ноль</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $anketaData:=$declar/Заявитель
let $idCard:=$declar/Заявитель/УТ:УдостоверяющийДокумент
return local:getResult(
					if (count($idCard) > 0) then
						for $ic in $idCard
							return if (local:valueInSequence($ic/УТ:Тип, ('ВОЕННЫЙ БИЛЕТ', 'ПАСПОРТ МОРЯКА', 'ВОЕН БИЛЕТ ОЗ'))) then
								if (matches($ic/УТ:Номер, '^0')) then ()
								else local:result(local:nodePosition($ic/УТ:Номер),'','','')
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>40</КодРезультата>
</Проверка>
<Проверка ID="1">
<Описание>Если тип документа отличен от 'СВИД О РОЖД', то Дата выдачи должна быть позже Даты рождения</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $anketaData:=$declar/Представитель/УТ:АнкетныеДанные
let $idCard:=$declar/Представитель/УТ:АнкетныеДанные/УТ:УдостоверяющийДокумент
return local:getResult(
					if (count($idCard) > 0) then
						for $ic in $idCard
							return if ($ic/УТ:Тип != 'СВИД О РОЖД') then
								let $dateBirth := $ic/parent::*/УТ:ДатаРождения  
								return if (local:notExistsOrEmpty($dateBirth)) then ()
									else
										if ($ic/УТ:ДатаВыдачи > $dateBirth) then ()
										else local:result(local:nodePosition($ic/УТ:ДатаВыдачи),'','','')
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>30</КодРезультата>
</Проверка>
<Проверка ID="2">
<Описание>Если тип документа - 'СВИД О РОЖД', то Дата выдачи должна быть позже либо равна Дате рождения</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $anketaData:=$declar/Представитель/УТ:АнкетныеДанные
let $idCard:=$declar/Представитель/УТ:АнкетныеДанные/УТ:УдостоверяющийДокумент
return local:getResult(
					if (count($idCard) > 0) then
						for $ic in $idCard
							return if ($ic/УТ:Тип = 'СВИД О РОЖД') then
								let $dateBirth := $ic/parent::*/УТ:ДатаРождения
								return if (local:notExistsOrEmpty($dateBirth)) then ()
									else
										if ($ic/УТ:ДатаВыдачи >= $dateBirth) then ()
										else local:result(local:nodePosition($ic/УТ:ДатаВыдачи),'','','')
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>30</КодРезультата>
</Проверка>
<Проверка ID="3">
<Описание>Дата рождения должна быть как минимум на 14 лет раньше 'Даты выдачи' 'ПАСПОРТА' или 'ПАСПОРТА РОССИИ'</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $anketaData:=$declar/Представитель/УТ:АнкетныеДанные
let $idCard:=$declar/Представитель/УТ:АнкетныеДанные/УТ:УдостоверяющийДокумент
return local:getResult(
					if (count($idCard) > 0) then
						for $ic in $idCard
							return if (local:valueInSequence($ic/УТ:Тип, ('ПАСПОРТ', 'ПАСПОРТ РОССИИ'))) then
								let $dateBirth := $ic/parent::*/УТ:ДатаРождения
								return if (local:notExistsOrEmpty($dateBirth)) then ()
									else
										if (local:addYear($dateBirth, 14) > $ic/УТ:ДатаВыдачи) then
											local:result(local:nodePosition($dateBirth),'','','')
										else ()
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>20</КодРезультата>
</Проверка>
<Проверка ID="4">
<Описание>Если тип документа - 'ПАСПОРТ', 'ПАСПОРТ РОССИИ', 'СВИД О РОЖД', 'ЗГПАСПОРТ', 'УДОСТ ОФИЦЕРА', 'ПАСПОРТ МОРФЛТ', 'ВОЕННЫЙ БИЛЕТ', 'ПАСПОРТ МОРЯКА', 'ВОЕН БИЛЕТ ОЗ', 'ДИППАСПОРТ РФ' или 'ЗГПАСПОРТ РФ', то 'Серия' должна быть указана</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $anketaData:=$declar/Представитель/УТ:АнкетныеДанные
let $idCard:=$declar/Представитель/УТ:АнкетныеДанные/УТ:УдостоверяющийДокумент
return local:getResult(
					if (count($idCard) > 0) then
						for $ic in $idCard
							return if (local:valueInSequence($ic/УТ:Тип, ('ПАСПОРТ', 'ПАСПОРТ РОССИИ', 'СВИД О РОЖД', 'ЗГПАСПОРТ', 'УДОСТ ОФИЦЕРА', 'ПАСПОРТ МОРФЛТ', 'ВОЕННЫЙ БИЛЕТ', 'ПАСПОРТ МОРЯКА', 'ВОЕН БИЛЕТ ОЗ', 'ДИППАСПОРТ РФ', 'ЗГПАСПОРТ РФ'))) then
								if (not(local:notExistsOrEmpty($ic/УТ:Серия))) then ()
								else local:result(local:nodePosition($ic),'','','')
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>20</КодРезультата>
</Проверка>
<Проверка ID="5">
<Описание>Если тип документа - 'ПАСПОРТ' или 'СВИД О РОЖД', то 'Серия' должна соответствовать шаблону '[римские цифры в диапазоне от I до XLIX] – [2 буквы русского алфавита]'</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $anketaData:=$declar/Представитель/УТ:АнкетныеДанные
let $idCard:=$declar/Представитель/УТ:АнкетныеДанные/УТ:УдостоверяющийДокумент
return local:getResult(
					if (count($idCard) > 0) then
						for $ic in $idCard
							return if (local:valueInSequence($ic/УТ:Тип, ('ПАСПОРТ', 'СВИД О РОЖД'))) then
								if (not(local:notExistsOrEmpty($ic/УТ:Серия))) then
									if (matches($ic/УТ:Серия,'^(XL?|X{0,3})(V?I{0,3}|I[VX])\-[А-ЯЁ]{2}$')) then () else local:result(local:nodePosition($ic/УТ:Серия),'','','')
								else local:result(local:nodePosition($ic),'','','')
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>40</КодРезультата>
</Проверка>
<Проверка ID="6">
<Описание>Если тип документа - 'ПАСПОРТ РОССИИ', то 'Серия' должна содержать 4 арабские цифры</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $anketaData:=$declar/Представитель/УТ:АнкетныеДанные
let $idCard:=$declar/Представитель/УТ:АнкетныеДанные/УТ:УдостоверяющийДокумент
return local:getResult(
					if (count($idCard) > 0) then
						for $ic in $idCard
							return if ($ic/УТ:Тип = 'ПАСПОРТ РОССИИ') then
								if (not(local:notExistsOrEmpty($ic/УТ:Серия))) then
									if (matches($ic/УТ:Серия,'^\d{4}$')) then () else local:result(local:nodePosition($ic/УТ:Серия),'','','')
								else local:result(local:nodePosition($ic),'','','')
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>40</КодРезультата>
</Проверка>
<Проверка ID="7">
<Описание>Если тип документа - 'ЗГПАСПОРТ', 'ДИППАСПОРТ РФ' или 'ЗГПАСПОРТ РФ', то 'Серия' должна содержать 2 арабские цифры</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $anketaData:=$declar/Представитель/УТ:АнкетныеДанные
let $idCard:=$declar/Представитель/УТ:АнкетныеДанные/УТ:УдостоверяющийДокумент
return local:getResult(
					if (count($idCard) > 0) then
						for $ic in $idCard
							return if (local:valueInSequence($ic/УТ:Тип, ('ЗГПАСПОРТ', 'ДИППАСПОРТ РФ', 'ЗГПАСПОРТ РФ'))) then
								if (not(local:notExistsOrEmpty($ic/УТ:Серия))) then
									if (matches($ic/УТ:Серия,'^\d{2}$')) then () else local:result(local:nodePosition($ic/УТ:Серия),'','','')
								else local:result(local:nodePosition($ic),'','','')
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>40</КодРезультата>
</Проверка>
<Проверка ID="8">
<Описание>Если тип документа - 'ВОЕННЫЙ БИЛЕТ', 'ПАСПОРТ МОРЯКА', 'ВОЕН БИЛЕТ ОЗ', 'УДОСТ ОФИЦЕРА' или 'ПАСПОРТ МОРФЛТ', то 'Серия' должна содержать ровно 2 буквы русского алфавита</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $anketaData:=$declar/Представитель/УТ:АнкетныеДанные
let $idCard:=$declar/Представитель/УТ:АнкетныеДанные/УТ:УдостоверяющийДокумент
return local:getResult(
					if (count($idCard) > 0) then
						for $ic in $idCard
							return if (local:valueInSequence($ic/УТ:Тип, ('ВОЕННЫЙ БИЛЕТ', 'ПАСПОРТ МОРЯКА', 'ВОЕН БИЛЕТ ОЗ', 'УДОСТ ОФИЦЕРА', 'ПАСПОРТ МОРФЛТ'))) then
								if (not(local:notExistsOrEmpty($ic/УТ:Серия))) then
									if (matches($ic/УТ:Серия,'^[А-ЯЁ]{2}$')) then () else local:result(local:nodePosition($ic/УТ:Серия),'','','')
								else local:result(local:nodePosition($ic),'','','')
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>40</КодРезультата>
</Проверка>
<Проверка ID="9">
<Описание>Если тип документа - 'ВОЕННЫЙ БИЛЕТ', 'ПАСПОРТ МОРЯКА' или 'ВОЕН БИЛЕТ ОЗ', то элемент 'Номер' должен содержать в первой позиции арабскую цифру ноль</Описание>
<РезультатЗапроса>
{
let $declar:=$root/МЗРК
let $anketaData:=$declar/Представитель/УТ:АнкетныеДанные
let $idCard:=$declar/Представитель/УТ:АнкетныеДанные/УТ:УдостоверяющийДокумент
return local:getResult(
					if (count($idCard) > 0) then
						for $ic in $idCard
							return if (local:valueInSequence($ic/УТ:Тип, ('ВОЕННЫЙ БИЛЕТ', 'ПАСПОРТ МОРЯКА', 'ВОЕН БИЛЕТ ОЗ'))) then
								if (matches($ic/УТ:Номер, '^0')) then ()
								else local:result(local:nodePosition($ic/УТ:Номер),'','','')
							else ()
					else ()
				)}
</РезультатЗапроса>
<КодРезультата>40</КодРезультата>
</Проверка>
</БлокПроверок>

